VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bibliotek"
   ClientHeight    =   6885
   ClientLeft      =   150
   ClientTop       =   750
   ClientWidth     =   5775
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   459
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   385
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRun 
      Caption         =   "&Kjr"
      Height          =   285
      Left            =   5040
      TabIndex        =   10
      Top             =   4320
      Width           =   615
   End
   Begin VB.CommandButton cmdSearch 
      Caption         =   "S&k"
      Height          =   375
      Left            =   4320
      TabIndex        =   9
      Top             =   6360
      Width           =   1335
   End
   Begin VB.PictureBox picCards 
      BorderStyle     =   0  'None
      Height          =   1365
      Left            =   120
      ScaleHeight     =   91
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   369
      TabIndex        =   6
      Top             =   120
      Width           =   5535
      Begin VB.VScrollBar vscCards 
         Height          =   1365
         Left            =   5280
         Max             =   0
         TabIndex        =   8
         Top             =   0
         Width           =   255
      End
      Begin VB.CommandButton cmdCard 
         Height          =   375
         Index           =   0
         Left            =   0
         TabIndex        =   7
         Top             =   0
         Width           =   1215
      End
   End
   Begin VB.TextBox txtDescription 
      Height          =   1455
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   4680
      Width           =   5535
   End
   Begin VB.TextBox txtTitle 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   4320
      Width           =   4815
   End
   Begin VB.ListBox lstAddresses 
      Height          =   2205
      Left            =   120
      TabIndex        =   0
      Top             =   1800
      Width           =   5535
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "&Slett"
      Height          =   375
      Left            =   2880
      TabIndex        =   5
      Top             =   6360
      Width           =   1455
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Lagre"
      Height          =   375
      Left            =   1440
      TabIndex        =   4
      Top             =   6360
      Width           =   1455
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "L&egg til"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   6360
      Width           =   1335
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&Fil"
      Begin VB.Menu mnuOpen 
         Caption         =   "&pne fil"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Lagre fil som"
      End
      Begin VB.Menu mnuLine 
         Caption         =   "-"
      End
      Begin VB.Menu mnuOpenStandard 
         Caption         =   "&pne standard"
      End
      Begin VB.Menu mnuSaveStandard 
         Caption         =   "&Lagre standard"
      End
      Begin VB.Menu mnuLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Logg ut"
      End
   End
   Begin VB.Menu mnuDatabase 
      Caption         =   "&Database"
      Begin VB.Menu mnuChangePassword 
         Caption         =   "&Endre passord"
      End
      Begin VB.Menu mnuAdminCards 
         Caption         =   "&Administrer kartotek"
      End
      Begin VB.Menu mnuLine3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSearch 
         Caption         =   "&Sk"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Public WithEvents Cards As clsCards
Attribute Cards.VB_VarHelpID = -1
Public OpenSave As New clsOpenSave
Public Dialog As New clsDialog
Public CurrentCard As Long
Public Changed As Boolean

Public Sub LoadCards(ByVal Amout As Long)
    
    Dim Tell As Long, lngMax As Long
    
    If Amout < 11 Then
        Amout = 11
    End If
    
    ' Unload other card-buttons
    For Tell = 1 To cmdCard.UBound
        Unload cmdCard(Tell)
    Next
    
    ' Get the caption of the first card
    cmdCard(0).Caption = Cards.CardName(0)
    cmdCard(0).Enabled = (cmdCard(0).Caption <> "")
    
    ' Reload the card-buttons
    For Tell = 1 To Amout
        
        Load cmdCard(Tell)
    
        cmdCard(Tell).Visible = True
        cmdCard(Tell).Caption = Cards.CardName(Tell)
        cmdCard(Tell).Left = cmdCard(Tell - 1).Left + cmdCard(Tell - 1).Width + 8
        cmdCard(Tell).Top = cmdCard(Tell - 1).Top
        cmdCard(Tell).Enabled = (cmdCard(Tell).Caption <> "")
        
        If cmdCard(Tell).Left > picCards.Width - cmdCard(Tell).Width - 8 Then
            cmdCard(Tell).Left = 0
            cmdCard(Tell).Top = cmdCard(Tell).Top + cmdCard(Tell).Height + 8
        End If
        
    Next
    
    ' Update the scroll
    lngMax = RoundEx(cmdCard.Count / 4) - 3
    vscCards.Max = IIf(lngMax < 0, 0, lngMax)
    
    If Not Cards.IsCard(CurrentCard) Then
        CurrentCard = 0
    End If
    
    ' Update it
    UpdateAddressElement

End Sub

Public Function RoundEx(ByVal Value As Double) As Long

    If Int(Value) <> Value Then
        Value = Int(Value) + 1
    End If
    
    ' Return
    RoundEx = Value

End Function

Public Sub CheckSave()

    If Changed Then
        If MsgBox("nsker du  lagre endringene", vbQuestion + vbYesNo, "Lagre?") = vbYes Then
            SaveData Cards.FilePath
        End If
    End If

End Sub

Public Sub UpdateAddresses(Optional UpdateElement As Boolean = True)
    
    Dim Tell As Long
    
    ' Clear the addresses
    lstAddresses.Clear
    
    For Tell = 0 To Cards.AddressCount(CurrentCard)
        lstAddresses.AddItem Cards.AddressName(CurrentCard, Tell)
    Next
    
    ' Select the first element
    If lstAddresses.ListCount > 0 Then
        lstAddresses.ListIndex = 0
    End If
    
    ' Update this element
    If UpdateElement Then
        UpdateAddressElement
    End If

End Sub

Public Sub SelectAddress(ByVal Index As Long)

    ' Select this address
    lstAddresses.ListIndex = Index
    
    ' Update it
    UpdateAddressElement

End Sub

Public Sub SaveAddress(ByVal Index As Long)

    ' Save this element
    Cards.AddressName(CurrentCard, Index) = txtTitle.Text
    Cards.AddressDescription(CurrentCard, Index) = txtDescription.Text

    ' Update it
    UpdateAddresses False

End Sub

Public Sub UpdateAddressElement()

    txtTitle.Text = Cards.AddressName(CurrentCard, lstAddresses.ListIndex)
    txtDescription.Text = Cards.AddressDescription(CurrentCard, lstAddresses.ListIndex)

End Sub

Private Sub Cards_CardAdded()

    ' Update cards
    LoadCards Cards.CardCount

End Sub

Private Sub Cards_CardRemoved()

    ' Update cards
    LoadCards Cards.CardCount

End Sub

Private Sub cmdAdd_Click()

    Dim lngIndex As Long, RetProp As New PropertyBag

    ' Set the reference form
    Set Dialog.ReferenceForm = frmAdd
    
    ' Show the dialog
    Set RetProp = Dialog.ShowDialog(New PropertyBag)
    
    If RetProp.ReadProperty("Returned", "") = "OK" Then
        ' Add a card
        lngIndex = Cards.AddAddress(CurrentCard, RetProp.ReadProperty("txtAddress", ""), RetProp.ReadProperty("txtDescription", ""))
        
        ' Update information
        UpdateAddresses False
    
        ' Select this element
        SelectAddress lngIndex
        
        ' It has now been changed
        Changed = True
    End If

End Sub

Private Sub cmdCard_Click(Index As Integer)

    ' Set this to the current card
    CurrentCard = Index
    
    ' Update the information
    UpdateAddresses

End Sub

Private Sub cmdDelete_Click()

    ' Delete this address
    Cards.DeleteAddress CurrentCard, lstAddresses.ListIndex
    
    ' Update everything
    UpdateAddresses

    ' It has now been changed
    Changed = True

End Sub

Private Sub cmdRun_Click()

    ' Execute the address
    ShellExecute Me.hwnd, vbNullString, "http://" & txtTitle.Text, vbNullString, "C:\", SW_SHOWNORMAL

End Sub

Private Sub cmdSave_Click()

    Dim lastIndex As Long

    lastIndex = lstAddresses.ListIndex
    SaveAddress lastIndex
    lstAddresses.ListIndex = lastIndex
    
    ' Update element
    UpdateAddressElement
    
    ' It has now been changed
    Changed = True

End Sub

Public Sub LoadData(Optional ByVal sPath As String)

    Set Cards = New clsCards

    If sPath = "" Then
        sPath = ValidPath(App.Path) & "Data.dat"
    End If

    ' See if we need to save
    CheckSave
    
    ' Load the data
    Cards.LoadCards sPath

    ' Update everyting
    UpdateAddresses

    ' We no longer has anything to save
    Changed = False

End Sub

Public Sub SaveData(Optional ByVal sPath As String)

    If sPath = "" Then
        sPath = ValidPath(App.Path) & "Data.dat"
    End If
    
    ' Save the current data in the textboxes
    cmdSave_Click

    ' Save the data
    Cards.SaveCards sPath

    ' We no longer has anything to save
    Changed = False

End Sub

Public Sub AuthorizeUser()

    ' Disable this form
    Me.Enabled = False
    
    ' Show the login form
    frmLogin.Show

End Sub

Private Sub cmdSearch_Click()

    Dim sText As String, lCard As Long, lAddress As Long

    sText = InputBox("Skriv inn skestrengen")
    
    For lCard = 0 To Cards.CardCount

        ' Search in every address
        For lAddress = 0 To Cards.AddressCount(lCard)
            If Cards.IsAddress(lCard, lAddress) Then
                If InStr(1, Cards.AddressName(lCard, lAddress) & Cards.AddressDescription(lCard, lAddress), sText, vbTextCompare) <> 0 Then
                
                    ' Move to this card and update addresses
                    CurrentCard = lCard
                    UpdateAddresses False
                    
                    ' Select and update the address
                    lstAddresses.ListIndex = lAddress
                    UpdateAddressElement
                
                End If
            End If
        Next
        
    Next

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Dim Form As Form

    ' Check and see if saving is requried
    CheckSave
    
    For Each Form In Forms
        Unload Form
    Next

End Sub

Private Sub lstAddresses_Click()

    ' Update element
    UpdateAddressElement

End Sub

Private Sub lstAddresses_KeyDown(KeyCode As Integer, Shift As Integer)
    
    ' Update element
    UpdateAddressElement

End Sub

Private Sub mnuAdminCards_Click()

    Set frmCards.Cards = Cards
    
    frmCards.Show
    frmCards.UpdateCards

End Sub

Private Sub mnuChangePassword_Click()

    ' Change the password
    Cards.AdminPass = InputBox("Skriv inn det nye passordet")

    ' It has now been changed
    Changed = True

End Sub

Private Sub mnuExit_Click()

    Unload Me

End Sub

Private Sub mnuOpen_Click()

    OpenSave.Filter = "Database-filer .dat" & Chr(0) & "*.dat"
    OpenSave.OpenFile Me.hwnd, "pne database ..."
    
    If OpenSave.File <> "" Then
        If Dir(OpenSave.File) <> "" Then
            LoadData OpenSave.File
            AuthorizeUser
        Else
            MsgBox "Kunne ikke pne fil", vbCritical, "Feil"
        End If
    End If

End Sub

Private Sub mnuOpenStandard_Click()

    ' Load the default database and authorize user
    LoadData
    AuthorizeUser

End Sub

Private Sub mnuSave_Click()

    OpenSave.Filter = "Database-filer .dat" & Chr(0) & "*.dat"
    OpenSave.SaveFile Me.hwnd, "Lagre database ..."
    
    If OpenSave.File <> "" Then
        SaveData OpenSave.File
    End If

End Sub

Private Sub mnuSaveStandard_Click()

    ' Save the data
    SaveData

End Sub

Private Sub vscCards_Change()

    Dim Tell As Long

    cmdCard(0).Top = -(vscCards.Value * (cmdCard(0).Height + 8))

    ' Move everything to place
    For Tell = cmdCard.LBound + 1 To cmdCard.UBound
    
        cmdCard(Tell).Left = cmdCard(Tell - 1).Left + cmdCard(Tell - 1).Width + 8
        cmdCard(Tell).Top = cmdCard(Tell - 1).Top
        
        If cmdCard(Tell).Left > picCards.Width - cmdCard(Tell).Width - 8 Then
            cmdCard(Tell).Left = 0
            cmdCard(Tell).Top = cmdCard(Tell).Top + cmdCard(Tell).Height + 8
        End If
        
    Next

End Sub
