Attribute VB_Name = "modMain"
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Declare Function GetTickCount Lib "kernel32" () As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Const SW_SHOWNORMAL = 1

Public Sub Main()

    ' Show the splash
    frmSplash.Show
    
    ' Wait 5 seconds
    Wait 5000
    
    ' Hide the splasg
    frmSplash.Hide

    ' Show the login form
    frmLogin.Show

End Sub

Public Sub Wait(lngTime As Long)

    Dim lStart As Long
    
    lStart = GetTickCount

    Do Until (GetTickCount - lStart >= lngTime)
    
        If GetKeyState(vbKeyEscape) And &HF0000000 Then
            Exit Do
        End If
    
        Sleep 10
        DoEvents
    Loop

End Sub

Public Function ValidPath(sPath As String) As String

    ValidPath = sPath & IIf(Right(sPath, 1) = "\", "", "\")

End Function

